PGOBLIN_BANG(-f)
  Copyright (C)2022..2023 @BABOLO http://www.babolo.ru/
  pkg = lrwi-readcity-in
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: lrwi-readcity-in.pgoblin.m4,v 1.12 2024/10/27 20:57:18 babolo Exp $

lRwI_PreA
#perform 0002  ########################################################################    ####
CREATE TEMP TABLE SQNM(tmplevl)                         --  
     ( SQAT(levl)  INTEGER PRIMARY KEY AUTOINCREMENT      --  
     , SQAT(name)  text    NOT NULL                       -- 
     , SQAT(ordr)  int                                    -- 
     ) STRICT
;
#perform 0002  ##############################################################     ####
INSERT INTO SQNM(tmplevl)(SQAT(levl), SQAT(name), SQAT(ordr))
 VALUES ( 1, ' A1 ()'           , 10)
      , ( 3, ' B1 ( )', 30)
      , ( 4, ' B2 ( )', 40)
;
#begin   0002  ###############################################################     ####
#end     0002
#select  _002
DELETE FROM SQNM(levl)
 WHERE SQAT(levl) NOT IN(SELECT SQAT(levl) FROM SQNM(tmplevl))
 RETURNING '-levl', *
;
#display 00_00q
#select  _002
UPDATE SQNM(levl)
   SET SQAT(name) = SQNM(tmplevl).SQAT(name)
     , SQAT(ordr) = SQNM(tmplevl).SQAT(ordr)
 FROM SQNM(tmplevl)
 WHERE SQNM(tmplevl).SQAT(levl) == SQNM(levl).SQAT(levl)
   AND (  SQNM(tmplevl).SQAT(name) IS NOT SQNM(levl).SQAT(name)
       OR SQNM(tmplevl).SQAT(ordr) IS NOT SQNM(levl).SQAT(ordr)
       )
 RETURNING '~levl', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(levl)
 SELECT * FROM SQNM(tmplevl)
 RETURNING '+levl', *
;
#display 00_00q
#perform 0002  ###################################################################    ####
CREATE TEMP TABLE SQNM(tmpdem4)                         --  
     ( SQAT(demo)  INTEGER PRIMARY KEY AUTOINCREMENT      -- 
     , SQAT(exec)  text    NOT NULL                       -- 
     ) STRICT
;
#perform 0002  #######################################################     ####
INSERT INTO SQNM(tmpdem4)(SQAT(demo), SQAT(exec))
 VALUES ( 0, '
##perform 0002
CREATE TEMP TABLE _(i INTEGER PRIMARY KEY, _ text) STRICT;
##perform 0012
WITH a AS(SELECT ?1 AS SQAT(text)
               , SQNM(comb).SQAT(poin) AS SQAT(poin)
               , SQNM(comb).SQAT(sdem) AS SQAT(sdem)
               , SQNM(comb).SQAT(ordr) AS SQAT(ordr)
           FROM  SQNM(comb)
           WHERE SQNM(comb).SQAT(proj) == LRWINUM AND SQNM(comb).SQAT(objc) == ?1
         )
INSERT INTO _(_)
 SELECT ''
###select  3012
   SELECT SQNM(comb).SQAT(poin), SQNM(comb).SQAT(sdem)
    FROM SQNM(comb)
    WHERE SQNM(comb).SQAT(proj) == LRWINUM
      AND SQNM(comb).SQAT(objc) == ?
      AND SQNM(comb).SQAT(poin) == '' || a.SQAT(poin) || ''
;
###select  4012
   SELECT SQNM(dem4).SQAT(exec)
    FROM SQNM(comb) JOIN SQNM(dem4) USING(SQAT(demo))
    WHERE SQNM(comb).SQAT(proj) == LRWINUM
      AND SQNM(comb).SQAT(objc) == ?
      AND SQNM(comb).SQAT(poin) == '' || a.SQAT(poin) || ''
;
###eval    04
###close   404
''FROM a
ORDER BY a.ordr, a.text
;
##select  2002
SELECT _ FROM _ ORDER BY i;
##eval    02
##perform 0002
DROP TABLE _;
##close   404
##close   303
##close   202
')  ------------------------------------------------------------------------------------------  0  ----
      , ( 1, '
##select  9032
SELECT SQNM(qans).SQAT(objc)                                                      AS ques
     , SQNM(qans).SQAT(poin)                                                      AS poin
     , CASE WHEN SQNM(pamparam).SQAT(answ) IS SQNM(qans).SQAT(answ) THEN '''' END AS color
     , CASE WHEN SQNM(pamparam).SQAT(answ) <> ''''
            THEN COALESCE(SQNM(qans).SQAT(full), SQNM(qans).SQAT(answ))
       END                                                                        AS answ
 FROM SQNM(qans) JOIN SQNM(pamparam) ON(   SQNM(qans).SQAT(poin) == SQNM(pamparam).SQAT(poin)
                                       AND SQNM(qans).SQAT(objc) == SQNM(pamparam).SQAT(ques)
                                       )
 WHERE SQNM(qans).SQAT(proj) = LRWINUM
   AND SQNM(qans).SQAT(objc) = ?1
;
##display 00900d
##display 00300i
##select  9032
 SELECT CAST(SQNM(pamparam).SQAT(ques) AS TEXT)
     || ''_''
     || CAST(SQNM(pamparam).SQAT(poin) AS TEXT) AS n
      , SQNM(pamparam).SQAT(answ)               AS p
  FROM SQNM(pamparam)
  WHERE SQNM(pamparam).SQAT(ques) <> ?1
UNION
 SELECT CAST(SQNM(pamparam).SQAT(ques) AS TEXT) AS n
      , ''s''                                   AS p
  FROM SQNM(pamparam)
  WHERE SQNM(pamparam).SQAT(ques) <> ?1
;
##display 00900h
##select  903_
SELECT ''CIPALITEVAR/LRWINUM/'' || ?
##cat     09
##close   909
##display 00300o
')  ------------------------------------------------------------------------------------------  1  ----
      , ( 2, '
##select  201_
SELECT ''CIPALITEVAR/LRWINUM/'' || ?
##cat     02
##close   202
')  ------------------------------------------------------------------------------------------  2  ----
      , ( 3, '
##select  503_
SELECT ''CIPALITEVAR/LRWINUM/'' || ?
##cat     05
##close   505
')  ------------------------------------------------------------------------------------------  3  ----
      , ( 4, '
##select  6012
SELECT ?2, SQNM(text).SQAT(head) FROM SQNM(text) WHERE SQNM(text).SQAT(text) == ?2;
##select  506_
SELECT CINM(x).CIAT(sess)  AS sess
     , CINM(pnode).CIAT(p) AS page
     , ?                   AS sele
     , ?                   AS head
 FROM CINM(x), CINM(pnode)
 WHERE CINM(pnode).CIAT(m) == ''lrwi-textcase'' AND CINM(pnode).CIAT(v) == ''text''
;
##style   00y001
just
##display 005001
##close   505001
##close   606
')  ------------------------------------------------------------------------------------------  4  ----
      , ( 5, '
##select  9032
SELECT SQNM(qans).SQAT(objc)                                                      AS ques
     , SQNM(qans).SQAT(poin)                                                      AS poin
     , CASE WHEN COALESCE(SQNM(pamparam).SQAT(answ), ''off'') == SQNM(qans).SQAT(answ)
            THEN ''''
       END                                                                        AS color
--   , SQNM(pamparam).SQAT(answ)                                                  AS value
 FROM SQNM(qans) LEFT JOIN SQNM(pamparam) ON(   SQNM(qans).SQAT(poin) == SQNM(pamparam).SQAT(poin)
                                            AND SQNM(qans).SQAT(objc) == SQNM(pamparam).SQAT(ques)
                                            )
 WHERE SQNM(qans).SQAT(proj) = LRWINUM
   AND SQNM(qans).SQAT(objc) = ?1
   AND EXISTS(SELECT 1 FROM SQNM(p) WHERE SQAT(n) = ?1 AND SQAT(p) = ''s'')
;
##display 00900k
##display 00300i
##select  9032
 SELECT CAST(SQNM(pamparam).SQAT(ques) AS TEXT)
     || ''_''
     || CAST(SQNM(pamparam).SQAT(poin) AS TEXT) AS n
      , SQNM(pamparam).SQAT(answ)               AS p
  FROM SQNM(pamparam)
  WHERE SQNM(pamparam).SQAT(ques) <> ?1
UNION
 SELECT CAST(SQNM(pamparam).SQAT(ques) AS TEXT) AS n
      , ''s''                                   AS p
  FROM SQNM(pamparam)
  WHERE SQNM(pamparam).SQAT(ques) <> ?1
;
##display 00900h
##select  903_
SELECT ''CIPALITEVAR/LRWINUM/'' || ?
##cat     09
##close   909
##display 00300o
')  ------------------------------------------------------------------------------------------  5  ----
;
#! 0 IO 1[0]  N 
        1[1]  
          IO 234 DB 2[_]
                     comb,   IO 3,   IO 4
   1 IO 3[0]  N 
     ST d[, iform]  form...  
          IO 9
                  style  , form, hidden  ,  N, /form.
---                lRwI_tExT, lRwI_tExV, lRwI_tE2T, lRwI_tE2V, lRwI_sElE, lRwI_sElV,
---              lRwI_sE2E, lRwI_sE2V
   2 IO 1[0]  N 
          IO 2
                   /p   
   3 IO 3[0]  N 
          IO 5
                   /p   
   4 IO 1[0]  N 
        1[1]  N   
                    
   5 IO 3[0]  N 
     ST k
          IO 9
                  style  , form, hidden  ,  N, /form.
---                lRwI_kNoP
#begin   0002  ########################################################     ####
#select  _002
DELETE FROM SQNM(dem4)
 WHERE (SQAT(demo)) NOT IN (SELECT SQAT(demo) FROM SQNM(tmpdem4))
 RETURNING '-dem4', *
;
#display 00_00q
#select  _002
UPDATE SQNM(dem4)
   SET SQAT(exec) = SQNM(tmpdem4).SQAT(exec)
 FROM SQNM(tmpdem4)
 WHERE SQNM(tmpdem4).SQAT(demo) == SQNM(dem4).SQAT(demo)
   AND SQNM(tmpdem4).SQAT(exec) IS NOT SQNM(dem4).SQAT(exec)
 RETURNING '~dem4', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(dem4)
 SELECT * FROM SQNM(tmpdem4)
 RETURNING '+dem4', SQAT(demo)
;
#display 00_00q
#end     0002
#perform 0002  ################################################################   N  1  ####
CREATE TEMP TABLE SQNM(tmpcomb)                        -- 
     ( SQAT(proj)  int NOT NULL                          -- 
     , SQAT(objc)  int NOT NULL                          -- 
     , SQAT(poin)  int NOT NULL                          --  
     , SQAT(ordr)  int                                   --   
     , SQAT(sdem)  int                                   -- 
     , SQAT(demo)  int  NOT NULL DEFAULT 0               --  
     , PRIMARY KEY(SQAT(proj), SQAT(objc), SQAT(poin))
     ) STRICT
;
#perform 0002  ###########################################################     ####
INSERT INTO SQNM(tmpcomb)
 VALUES ( LRWINUM, 3,  1, NULL, NULL, 1)
      , ( LRWINUM, 3,  2, NULL, NULL, 1)
      , ( LRWINUM, 7,  4, NULL, NULL, 3)
      , ( LRWINUM, 7,  5, NULL, NULL, 4)
      , ( LRWINUM, 7,  6, NULL, NULL, 3)
      , ( LRWINUM, 9,  8, NULL, NULL, 5)
      , ( LRWINUM, 9, 10, NULL, NULL, 5)
      , ( LRWINUM, 9, 11, NULL, NULL, 5)
      , ( LRWINUM, 9, 12, NULL, NULL, 5)
      , ( LRWINUM, 9, 13, NULL, NULL, 5)
      , ( LRWINUM, 9, 14, NULL, NULL, 5)
;
#begin   0002  ############################################################     ####
#select  _002
DELETE FROM SQNM(comb)
 WHERE (SQAT(objc), SQAT(poin)) NOT IN(SELECT SQAT(objc), SQAT(poin) FROM SQNM(tmpcomb))
   AND SQAT(proj) == LRWINUM
 RETURNING '-comb', *
;
#display 00_00q
#select  _002
UPDATE SQNM(comb)
   SET SQAT(ordr) = SQNM(tmpcomb).SQAT(ordr)
     , SQAT(sdem) = SQNM(tmpcomb).SQAT(sdem)
     , SQAT(demo) = SQNM(tmpcomb).SQAT(demo)
 FROM SQNM(tmpcomb)
 WHERE SQNM(tmpcomb).SQAT(proj) == SQNM(comb).SQAT(proj)
   AND SQNM(tmpcomb).SQAT(objc) == SQNM(comb).SQAT(objc)
   AND SQNM(tmpcomb).SQAT(poin) == SQNM(comb).SQAT(poin)
   AND (  SQNM(tmpcomb).SQAT(ordr) IS NOT SQNM(comb).SQAT(ordr)
       OR SQNM(tmpcomb).SQAT(sdem) IS NOT SQNM(comb).SQAT(sdem)
       OR SQNM(tmpcomb).SQAT(demo) IS NOT SQNM(comb).SQAT(demo)
       )
 RETURNING '~comb', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(comb)
 SELECT * FROM SQNM(tmpcomb)
 RETURNING '+comb', *
;
#display 00_00q
#end     0002
#perform 0002  #########################################################################    ####
CREATE TEMP TABLE SQNM(tmpques)                        --  
     ( SQAT(ques)  INTEGER PRIMARY KEY AUTOINCREMENT     -- 
     , SQAT(head)  text NOT NULL                         -- 
     , SQAT(levl)  int  NOT NULL                         --   
     , SQAT(ordr)  int  DEFAULT 999                      -- 
     , SQAT(demo)  int  NOT NULL DEFAULT 0               --  
     , SQAT(parm)  int                                   --  
     ) STRICT
;
#!###########################################################################     ####
#perform 0002  #################################################      ####
INSERT INTO SQNM(tmpques)(SQAT(levl), SQAT(ordr), SQAT(ques), SQAT(demo), SQAT(head), SQAT(parm))
 VALUES ( 1,   50, 9, 0, '  '             , NULL )
      , ( 3,   50, 3, 0, ' '         , NULL )
      , ( 4,   50, 7, 0, '   ',   42 )
;
#begin   0002  ###############################################################     ####
#select  _002
DELETE FROM SQNM(ques)
 WHERE SQAT(ques) NOT IN(SELECT SQAT(ques) FROM SQNM(tmpques))
 RETURNING '-ques', *
;
#display 00_00q
#select  _002
UPDATE SQNM(ques)
   SET SQAT(head) = SQNM(tmpques).SQAT(head)
     , SQAT(levl) = SQNM(tmpques).SQAT(levl)
     , SQAT(ordr) = SQNM(tmpques).SQAT(ordr)
     , SQAT(demo) = SQNM(tmpques).SQAT(demo)
     , SQAT(parm) = SQNM(tmpques).SQAT(parm)
 FROM SQNM(tmpques)
 WHERE SQNM(tmpques).SQAT(ques) == SQNM(ques).SQAT(ques)
   AND (  SQNM(tmpques).SQAT(head) IS NOT SQNM(ques).SQAT(head)
       OR SQNM(tmpques).SQAT(levl) IS NOT SQNM(ques).SQAT(levl)
       OR SQNM(tmpques).SQAT(ordr) IS NOT SQNM(ques).SQAT(ordr)
       OR SQNM(tmpques).SQAT(demo) IS NOT SQNM(ques).SQAT(demo)
       OR SQNM(tmpques).SQAT(parm) IS NOT SQNM(ques).SQAT(parm)
       )
 RETURNING '~ques', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(ques)
 SELECT * FROM SQNM(tmpques)
 RETURNING '+ques', *
;
#display 00_00q
#end     0002
#perform 0002  #############################################################   X   ####
CREATE TEMP TABLE SQNM(tmpquespart)                     --  
     ( SQAT(ques)  int     NOT NULL                       --   
     , SQAT(part)  int     NOT NULL                       --    
     , SQAT(lede)  int     NOT NULL                       --   
     , SQAT(ordr)  int                                    -- 
     , PRIMARY KEY(SQAT(ques), SQAT(part), SQAT(lede))
     ) STRICT
;
#perform 0002  ##################################################    X   ####
INSERT INTO SQNM(tmpquespart)(SQAT(ques), SQAT(part), SQAT(lede)) VALUES ( 3, 1,  1);
#begin   0002  ####################################################    X   ####
#select  _002
DELETE FROM SQNM(quespart)
 WHERE (SQAT(ques), SQAT(part), SQAT(lede)) NOT IN(SELECT SQAT(ques), SQAT(part), SQAT(lede)
                                                    FROM SQNM(tmpquespart)
                                                  )
 RETURNING '-quespart', *
;
#display 00_00q
#select  _002
UPDATE SQNM(quespart)
   SET SQAT(ordr) = SQNM(tmpquespart).SQAT(ordr)
 FROM SQNM(tmpquespart)
 WHERE SQNM(tmpquespart).SQAT(ques) == SQNM(quespart).SQAT(ques)
   AND SQNM(tmpquespart).SQAT(part) == SQNM(quespart).SQAT(part)
   AND SQNM(tmpquespart).SQAT(lede) == SQNM(quespart).SQAT(lede)
   AND SQNM(tmpquespart).SQAT(ordr) IS NOT SQNM(quespart).SQAT(ordr)
 RETURNING '~quespart', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(quespart)
 SELECT * FROM SQNM(tmpquespart)
 RETURNING '+quespart', *
;
#display 00_00q
#end     0002
#perform 0002  ##########################################################################    ####
CREATE TEMP TABLE SQNM(tempqans)            -- 
     ( SQAT(objc) int  NOT NULL               -- 
     , SQAT(poin) int  NOT NULL               --  
     , SQAT(answ) text NOT NULL               -- 
     , SQAT(full) text                        --  
     , PRIMARY KEY(SQAT(objc), SQAT(poin))
     ) STRICT
;
#exec    _  #################################################################     ####
/bin/sh
#
-c
#
cat THISDIR/../p/*.copy
#copyin  00_2
COPY SQNM(tempqans) FROM stdin;
#wait
#close   _0_
#perform 0002
CREATE TEMP TABLE SQNM(tmpqans)             -- 
     ( SQAT(objc) int  NOT NULL               --  
     , SQAT(poin) int  NOT NULL               --  
     , SQAT(vrnt) int  NOT NULL               --   
     , SQAT(answ) text NOT NULL               -- 
     , SQAT(full) text                        --  
     , PRIMARY KEY(SQAT(objc), SQAT(poin), SQAT(vrnt), SQAT(answ))
     ) STRICT
;
#perform 0002
WITH a AS(SELECT SQAT(objc)
               , SQAT(poin)
               , 0                                              AS SQAT(vrnt)
               , CASE WHEN regexp('^[0-9]+$', SQAT(answ))
                      THEN CAST(MIN(CAST(SQAT(answ) AS INTEGER)) AS TEXT)
                      ELSE MIN(SQAT(answ))
                 END                                            AS SQAT(answ)
           FROM SQNM(tempqans)
          GROUP BY SQAT(objc), SQAT(poin)
         UNION
          SELECT SQAT(objc)
               , SQAT(poin)
               , 1                                              AS SQAT(vrnt)
               , CASE WHEN regexp('^[0-9]+$', SQAT(answ))
                      THEN CAST(MAX(CAST(SQAT(answ) AS INTEGER)) AS TEXT)
                      ELSE MIN(SQAT(answ))
                 END                                            AS SQAT(answ)
           FROM SQNM(tempqans)
          GROUP BY SQAT(objc), SQAT(poin)
          HAVING COUNT(1) > 1
         )
INSERT INTO SQNM(tmpqans)
 SELECT SQAT(objc), SQAT(poin), SQAT(vrnt), SQAT(answ), SQAT(full)
  FROM a JOIN SQNM(tempqans) USING(SQAT(objc), SQAT(poin), SQAT(answ))
;
#begin   0002  ###############################################################     ####
#select  _002
DELETE FROM SQNM(qans)
 WHERE              (SQAT(objc), SQAT(poin), SQAT(vrnt), SQAT(answ))
       NOT IN(SELECT SQAT(objc), SQAT(poin), SQAT(vrnt), SQAT(answ) FROM SQNM(tmpqans))
   AND SQAT(proj) == LRWINUM
 RETURNING '-qans', *
;
#display 00_00q
#select  _002
UPDATE SQNM(qans)
   SET SQAT(full) = SQNM(tmpqans).SQAT(full)
 FROM SQNM(tmpqans)
 WHERE SQNM(tmpqans).SQAT(objc) == SQNM(qans).SQAT(objc)
   AND SQNM(tmpqans).SQAT(poin) == SQNM(qans).SQAT(poin)
   AND SQNM(tmpqans).SQAT(vrnt) == SQNM(qans).SQAT(vrnt)
   AND SQNM(tmpqans).SQAT(answ) == SQNM(qans).SQAT(answ)
   AND SQNM(tmpqans).SQAT(full) IS NOT SQNM(qans).SQAT(full)
 RETURNING '~qans', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(qans)
 SELECT LRWINUM, * FROM SQNM(tmpqans)
 RETURNING '+qans', *
;
#display 00_00q
#end     0002
lRwI_PosA
